package AIF;

/*
 * This Java source file was generated by the Gradle 'init' task.
 */


import AIF.AerialVehicles.fightrs.F15;
import AIF.AerialVehicles.fightrs.F16;
import AIF.AerialVehicles.katmams.Eitan;
import AIF.AerialVehicles.katmams.Kochav;
import AIF.AerialVehicles.katmams.Shoval;
import AIF.AerialVehicles.katmams.Zik;
import AIF.Entities.Coordinates;
import AIF.Modules.AttackModule;
import AIF.Modules.BDAModule;
import AIF.Modules.IntelligenceModule;

public class App {


    public static void main(String[] args) {

        System.out.println("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~|Start-1-F16|~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");

        F16 f16 = new F16(new Coordinates(0.0,0.0));
        try{
            f16.takeOff();
            f16.flyTo(new Coordinates(26000.0, 2.1));
            f16.land();
            if(f16.needMaintenance()){
                System.out.println("I could see this coming...");
            }
            f16.performMaintenance();
            if(!f16.needMaintenance()){
                System.out.println("And this too...");
            }
            f16.loadModule(new AttackModule());
            f16.activateModule(AttackModule.class, new Coordinates(26000.0, 2.0));
        }catch (Exception e){
            System.out.println("Well, there were bugs...");
        }


        System.out.println("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~|End|~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
        System.out.println();

        System.out.println("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~|Start-2-Shoval|~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");

        Shoval shoval = new Shoval(new Coordinates(0.0,0.0));
        try{
            shoval.takeOff();
            shoval.flyTo(new Coordinates(35650.2, 2.1));
            shoval.land();

            if(shoval.needMaintenance()){
                System.out.println("I could see this coming...");
            }

            shoval.performMaintenance();

            if(!shoval.needMaintenance()){
                System.out.println("And this too...");
            }

            shoval.loadModule(new AttackModule());

            try{
                System.out.println("try to activate 2 attack modules...");
                System.out.println("first...");
                shoval.activateModule(AttackModule.class, new Coordinates(26000.0, 2.0));
                System.out.println("second...");
                shoval.activateModule(AttackModule.class, new Coordinates(26000.0, 2.0));
            }catch (Exception e){
                System.out.println("The second attack didn't work cause there was just one attack module!");
            }

        }catch (Exception e){
            System.out.println("Well, there were bugs...");
        }


        System.out.println("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~|End|~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
        System.out.println();

        System.out.println("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~|Start-3-Eitan|~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");

        System.out.println();
        Eitan eitan = new Eitan(new Coordinates(0.0,0.0));
        try{
            eitan.takeOff();
            eitan.flyTo(new Coordinates(45000.0, 2.1));
            eitan.land();

            if(eitan.needMaintenance()){
                System.out.println("I could see this coming...");
            }

            eitan.performMaintenance();

            if(!eitan.needMaintenance()){
                System.out.println("And this too...");
            }

            try{
                System.out.println("try to load and activate bda module...");
                eitan.loadModule(new BDAModule());
                eitan.activateModule(BDAModule.class, new Coordinates(26000.0, 2.0));
            }catch (Exception e){
                System.out.println("didn't work cause eitan doesn't have an option for bda module!");
            }

            try{
                System.out.println("try to activate attack module...");
                eitan.activateModule(AttackModule.class, new Coordinates(26000.0, 2.0));
            }catch (Exception e){
                System.out.println("didn't work cause eitan doesn't have an attack module on its kit!");
            }

        }catch (Exception e){
            System.out.println("Well, there were bugs...");
        }


        System.out.println("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~|End|~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
        System.out.println();

        System.out.println("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~|Start-4-Zik|~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");

        Zik zik = new Zik(new Coordinates(0.0,0.0));
        try{
            zik.takeOff();
            zik.flyTo(new Coordinates(162000.0, 2.1));
            zik.land();

            if(zik.needMaintenance()){
                System.out.println("I could see this coming...");
            }

            zik.performMaintenance();

            if(!zik.needMaintenance()){
                System.out.println("And this too...");
            }

            try{
                System.out.println("try to load and activate bda module...");
                zik.loadModule(new BDAModule());
                zik.activateModule(BDAModule.class, new Coordinates(26000.0, 2.0));
            }catch (Exception e){}

            zik.takeOff();
            zik.flyTo(new Coordinates(10365.0, 20.0));
            zik.land();

            if(zik.needMaintenance()){
                System.out.println("I could see this coming...");
            }

            zik.performMaintenance();

            if(!zik.needMaintenance()){
                System.out.println("And this too...");
            }


        }catch (Exception e){
            System.out.println("Well, there were bugs...");
        }


        System.out.println("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~|End|~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
        System.out.println();

        System.out.println("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~|Start-5-F15|~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");

        F15 f15 = new F15(new Coordinates(1055.0,0.0));
        try{
            f15.takeOff();
            f15.flyTo(new Coordinates(162000.0, 2.1));
            f15.land();

            if(f15.needMaintenance()){
                System.out.println("I could see this coming...");
            }

            f15.performMaintenance();

            if(!f15.needMaintenance()){
                System.out.println("And this too...");
            }

            try{
                System.out.println("try to load bda module...");
                f15.loadModule(new BDAModule());
            }catch (Exception e){
                System.out.println("didn't work cause f15 cannot have bda module on its kit!");
            }
        }catch (Exception e){
            System.out.println("Well, there were bugs...");
        }


        System.out.println("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~|End|~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
        System.out.println();

        System.out.println("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~|Start-6-Kochav|~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");

        Kochav kochav = new Kochav(new Coordinates(1055.0,0.0));
        try{
            kochav.takeOff();
            kochav.flyTo(new Coordinates(162000.0, 2.1));
            System.out.println("try to hover over location...");
            kochav.hoverOverLocation(4);
            kochav.land();

            try{
                System.out.println("try to hover over location (will not work)...");
                kochav.hoverOverLocation(3);
            }catch (Exception e){

            }



            if(kochav.needMaintenance()){
                System.out.println("I could see this coming...");
            }

            kochav.performMaintenance();

            if(!kochav.needMaintenance()){
                System.out.println("And this too...");
            }

            try{
                System.out.println("try to load 6 modules...");
                System.out.println("first...");
                kochav.loadModule(new BDAModule());
                System.out.println("second...");
                kochav.loadModule(new IntelligenceModule());
                System.out.println("third...");
                kochav.loadModule(new IntelligenceModule());
                System.out.println("fourth...");
                kochav.loadModule(new AttackModule());
                System.out.println("fifth...");
                kochav.loadModule(new AttackModule());
                System.out.println("sixth...");
                kochav.loadModule(new AttackModule());
            }catch (Exception e){
                System.out.println("didn't work cause kochav can have only 5 modules on its kit!");
            }
        }catch (Exception e){
            System.out.println("Well, there were bugs...");
        }


        System.out.println("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~|End|~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
        System.out.println();
    }
}
